#include "stack.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void push(stack_t **phead, char *elem)
{
   stack_t *nowy = (stack_t *)malloc( sizeof(stack_t)); 

   nowy->str = strdup(elem);
   nowy->prev = *phead;

   *phead = nowy; 
}

char *pop(stack_t **phead)
{
    if (!*phead) return 0;

    stack_t *tmp = *phead;
    char *str = tmp->str;
    *phead = (*phead)->prev;
    free(tmp);

    return str;
}

void clear_stack( stack_t **phead)
{
    char *str;
    while (*phead) {
        str=pop(phead);
        free(str);
    }
}

void wypisz_stack( stack_t *head)
{
    printf("Stack contents:--->\n");
    while ( head ) {
        printf("%s\n", head->str);
        head = head->prev;
    }
    printf("<---\n\n");
}


void prepend(stack_t **phead, char *elem)
{
   stack_t *nowy = (stack_t *)malloc( sizeof(stack_t)); 

   nowy->str = strdup(elem);
   nowy->prev = 0;

   stack_t *tmp = *phead;
   if (!tmp) *phead = nowy;
   else {
	while ((tmp->prev)!=0) 
	    tmp=tmp->prev;
	tmp->prev = nowy;
   }
}

void odwroc_stack( stack_t **phead)
{
    //Tutaj wstaw kod
}
